#include <ArduinoBLE.h>

//----------------------------------------------------------------------------------------------------------------------
// BLE UUIDs
//----------------------------------------------------------------------------------------------------------------------
#define BLE_UUID_TEST_SERVICE               "4fafc201-1fb5-459e-8fcc-c5c9c331914b"
#define BLE_UUID_ACCELERATION               "beb5483e-36e1-4688-b7f5-ea07361b26a8"
//----------------------------------------------------------------------------------------------------------------------
// BLE
//----------------------------------------------------------------------------------------------------------------------
BLEService testService( BLE_UUID_TEST_SERVICE );
BLEIntCharacteristic accelerationCharacteristic("BLE_UUID_ACCELERATION", BLERead | BLENotify);
uint32_t accelerationX = 0;

bool setupBleMode()
{
  if ( !BLE.begin() )
  {
    return false;
  }

  // set advertised local name and service UUID:
  BLE.setDeviceName( "Nano33" );
  BLE.setLocalName( "Nano33" );
  BLE.setAdvertisedService( testService );
  // BLE add characteristics
  testService.addCharacteristic( accelerationCharacteristic );
  // add service
  BLE.addService( testService );
  // set the initial value for the characeristic:
  accelerationCharacteristic.writeValue( 0 );
  // start advertising
  BLE.advertise();
  return true;
}

void setup()
{
  Serial.begin( 9600 );
  //  while ( !Serial );
  setupBleMode();
} // setup

void loop()
{
  static long previousMillis = 0;
  // listen for BLE peripherals to connect:
  BLEDevice central = BLE.central();

  if ( central )
  {
    Serial.print( "Connected to central: " );
    Serial.println( central.address() );

    while ( central.connected() )
    {
      long interval = 2000;
      unsigned long currentMillis = millis();
      if( currentMillis - previousMillis > interval )
      {
        previousMillis = currentMillis;
          accelerationCharacteristic.writeValue( accelerationX );
          accelerationX++;
          Serial.println( accelerationX );
      }

    } // while connected

    Serial.print( F( "Disconnected from central: " ) );
    Serial.println( central.address() );
  } // if central
} // loop